# Enum SceneType

java.lang.Object
java.lang.Enum<SceneType>
com.codename1.home.SceneType

All Implemented Interfaces:
  `Comparable<SceneType>`

public enum SceneType extends Enum<SceneType>

What kind of `Scene` this is.

HomeKit gives its four built-in action sets distinct types and lets the user create more; the built-ins are the ones an ecosystem app surfaces specially, so an app that wants to match that presentation can.

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `ARRIVAL`
  The home's built-in "I'm home" scene.
  `DEPARTURE`
  The home's built-in "I'm leaving" scene.
  `SLEEP`
  The home's built-in "good night" scene.
  `TRIGGER_OWNED`
  A scene owned by an automation rather than by the user.
  `USER_DEFINED`
  A scene the user created.
  `WAKE_UP`
  The home's built-in "good morning" scene.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static SceneType`
  `valueOf(String name)`
  Returns the enum constant of this type with the specified name.
  `static SceneType[]`
  `values()`
  Returns an array containing the constants of this enum type, in the order they are declared.

  ### Methods inherited from class Enum

  `clone, compareTo, equals, getDeclaringClass, getEnumValues, hashCode, name, ordinal, setEnumValues, toString, valueOf`

  ### Methods inherited from class Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### WAKE_UP

    public static final SceneType WAKE_UP
    The home's built-in "good morning" scene.

  - ### SLEEP

    public static final SceneType SLEEP
    The home's built-in "good night" scene.

  - ### ARRIVAL

    public static final SceneType ARRIVAL
    The home's built-in "I'm home" scene.

  - ### DEPARTURE

    public static final SceneType DEPARTURE
    The home's built-in "I'm leaving" scene.

  - ### USER_DEFINED

    public static final SceneType USER_DEFINED
    A scene the user created.

  - ### TRIGGER_OWNED

    public static final SceneType TRIGGER_OWNED

    A scene owned by an automation rather than by the user.

    Not executable. It exists so a listing is complete and so a scene the user cannot run does not silently look like one they can; the automation that owns it decides when it fires, and this release does not expose automations. `Scene.isExecutable()` answers `false`.

- ## Method Details

  - ### values

    public static SceneType[] values()
    Returns an array containing the constants of this enum type, in the order they are declared.
    Returns:
      an array containing the constants of this enum type, in the order they are declared

  - ### valueOf

    public static SceneType valueOf(String name)
    Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum type has no constant with the specified name
      `NullPointerException` - if the argument is null